Subject: Re: [RFC] enhanced version of net_random()

From: Lee Revell <[email-masked]>
Date: Fri, 20 Aug 2004 17:24:15 -0400

On Fri, 2004-08-20 at 14:59, Andreas Dilger wrote:
> On Aug 20, 2004  13:59 -0400, Jean-Luc Cooke wrote:
> > Is there a reason why get_random_bytes() is unsuitable?
> > 
> > Keeping the number of PRNGs in the kernel to a minimum should a goal we can
> > all share.
> 
> For some uses a decent PRNG is enough, and the overhead of get_random_bytes()
> is much too high.

Agreed.  I have numbers to support the above.

>   We've needed something like this for a long time (something
> that gives decenly uniform numbers) and hacks to use useconds/cycles/etc do
> not cut it.  I for one welcome a simple in-kernel interface to
> e.g. get_urandom_bytes() (or net_random() as this is maybe inappropriately
> called) that is only pseudo-random but fast and efficient.

One problem is that AIUI, we incur this overhead even if a hardware RNG
is present.  This does not seem right.  Hardware RNGs are increasingly
common, Linux supports hardware RNGs from AMD, Intel, and VIA.

Lee